/*****************************************************************/
/*      cfortranclient.h                                         */
/*      Henri Casanova                                           */
/*****************************************************************/

#ifndef __NS_CFORTRANCLIENT_H
#define __NS_CFORTRANCLIENT_H


/**
 ** MACRO DEFINITIONS
 **/

#define CALL_FROM_FORTRAN 0
#define CALL_FROM_C       1

#define NB_MAX_REQUESTS 100

/**
 ** GLOBAL VARIABLES
 **/
NS_RequestDesc *requests[NB_MAX_REQUESTS]; /* XXXXXASFDASGPQRGOAKGA */
void **output_ptrs[NB_MAX_REQUESTS];

int proxy_pid;
int proxy_port;

/**
 ** FUNCTION PROTOTYPES
 **/

int assignConstantValues(NS_ProblemDesc*,NS_Object**,NS_Object**);
int assignFormulaValues(NS_ProblemDesc*,NS_Object**,NS_Object**);
int netslX(NS_ProblemDesc*,NS_VoidStarOrInt*);
int netslnbX(NS_ProblemDesc*,NS_VoidStarOrInt*);
int netslmajor(char*);
int netslX_assignment(NS_IPaddr_type,NS_ProblemDesc*,NS_VoidStarOrInt*);
int netslnbX_assignment(NS_IPaddr_type,NS_ProblemDesc*,NS_VoidStarOrInt*);

#ifndef WIN32 /*UNIX*/
int netsl(char*,...);
int netslnb(char*,...);
int netslwt(int);
int netslpr(int);
int netslpr_assignment(int);
int netslwt_assignment(int,int*);
int netslkill(int);
void netslerr(int);
int *netsl_farm(char*,...);

int netsl_assignment(char*,...);
int netslnb_assignment(char*,...);

#ifdef ADD_
void fnetsl_(char*,...);
#endif
#ifdef NOCHANGE
void fnetsl(char*,...);
#endif
#ifdef UPCASE 
void FNETSL(char*,...);
#endif
#ifdef ADD_
void fnetslerr_(int*);
#endif
#ifdef UPCASE  
void FNETSLERR(int*);
#endif
#ifdef NOCHANGE
void fnetslerr(int*);
#endif
#ifdef ADD_
void fnetslmajor_(char*);
#endif 
#ifdef UPCASE
void FNETSLMAJOR(char*);
#endif
#ifdef NOCHANGE
void fnetslmajor(char*);
#endif
#ifdef ADD_
void fnetslnb_(char*,...);
#endif
#ifdef UPCASE
void FNETSLNB(char*,...);
#endif
#ifdef NOCHANGE
void fnetslnb(char*,...);
#endif
#ifdef ADD_
void fnetslpr_(int*,int*);
#endif 
#ifdef UPCASE
void FNETSLPR(int*,int*);
#endif 
#ifdef NOCHANGE
void fnetslpr(int*,int*);
#endif
#ifdef ADD_
void fnetslwt_(int*,int*);
#endif
#ifdef UPCASE
void FNETSLWT(int*,int*);
#endif
#ifdef NOCHANGE
void fnetslwt(int*,int*);
#endif


#else /* WIN32 */

#ifdef WIN32DLL
/* Glue for Win32 Dynamic Link Library calls */
HINSTANCE gNetsolveDLL = NULL;
typedef int (*NETSL)(char *,...);
NETSL netsl;
typedef int (*NETSLNB)(char *,...);
NETSLNB netslnb;
typedef int (*NETSLWT)(int);
NETSLWT netslwt;
typedef int (*NETSLPR)(int);
NETSLPR netslpr;
typedef int (*NETSLERR)(int);
NETSLERR netslerr;
typedef int (*NETSL_FARM)(char *,...);
NETSL_FARM netsl_farm;

/* Otherwise just declare function prototypes */
#else

int netsl(char*,...);
int netslnb(char*,...);
int netslwt(int);
int netslpr(int);
void netslerr(int);
int *netsl_farm(char*,...);

#endif  /* WIN32DLL */

#endif /* WIN32 */





#endif

