/*****************************************************************/
/*      client.h                                                 */
/*      Henri Casanova                                           */
/*****************************************************************/

#ifndef __NS_CLIENT_H
#define __NS_CLIENT_H

#include "core.h"

/**
 ** MACRO DEFINITIONS
 **/

#define WAIT 0
#define PROBE 1

#define NOBLOCK 0
#define BLOCK 1

#define WAITMAGIC 0x5ADFACE

/**
 **  GLOBAL VARIABLES
 **/

extern int my_major;
extern int my_data_format;
extern int proxy_port;

/**
 **  FUNCTION PROTOTYPES
 **/

/* Low level */
int determineSizes(NS_ProblemDesc*,NS_Object**,NS_Object**,int*,int*,int*);
int getAllProblems(NS_ProblemDesc***);
int getAllServers(NS_ServerDesc***);
int getAllAgents(NS_AgentDesc***);
int getNumberOfServers();

/* High level */
void reportFailure(NS_IPaddr_type,char*,int,int,int);
int netsolveInfo(char*,NS_ProblemDesc**);
int killRequest(NS_RequestDesc*);
int netsolveBlocking(NS_ProblemDesc*,NS_Object**,NS_Object**,int*);
int netsolveBlockingAssignment(NS_IPaddr_type,NS_ProblemDesc*,NS_Object**,NS_Object**,int*);
NS_RequestDesc *netsolveSendRequest(NS_ProblemDesc*, NS_Object**,NS_Object**);
NS_RequestDesc *netsolveSendAssignment(NS_ProblemDesc*, NS_Object**,NS_Object**,NS_IPaddr_type);
int netsolveWaitRequest(NS_RequestDesc **, int *);
int netsolveWaitAssignment(NS_RequestDesc **, int *);
int netsolveProbeRequest(NS_RequestDesc **);
int netsolveProbeAssignment(NS_RequestDesc **);
int netsolveKillJob(NS_RequestDesc*);
void reportJobCompleted(NS_IPaddr_type);

/* Major */
int setMajor(char*);
int setMajorDefault(char*);

/* HBM */
int getStatusFromHBM(NS_RequestDesc*);



/* sequencing */
int netsolve_sequence_Blocking(NS_Node *top_node, int *elapsed);
NS_RequestDesc *netsolve_sequence_SendRequest(NS_Node *top_node);
int netsolveWaitRequest_sequence(NS_Node*, NS_RequestDesc **, int *);



#endif

