/*****************************************************************/
/*      netsolve.h                                               */
/*      Henri Casanova                                           */
/*****************************************************************/

#ifndef __NS_NETSOLVE_H
#define __NS_NETSOLVE_H

/* Sequences */
extern void*    NS_EndArg;           
#define NS_NULL   &NS_EndArg

/* Iterator */

typedef struct{
  char *expression;
}NS_IntIterator;

typedef struct{
  int *array;
  char *expression;
}NS_IntArrayIterator;

typedef struct{
  void **array;
  char *expression;
}NS_PtrArrayIterator;


typedef struct {
  int type;
  union {
    NS_IntIterator *int_iterator;
    NS_IntArrayIterator *int_array_iterator;
    NS_PtrArrayIterator *ptr_array_iterator;
  } it;
} NS_SpecificIterator;

typedef struct {
  int returned_type;
  int i;
  NS_SpecificIterator *specific;
}NS_Iterator;

NS_Iterator *ns_int(char*);
NS_Iterator *ns_int_array(int*,char*);
NS_Iterator *ns_ptr_array(void**,char*);

int netslmajor(char*);
void netslerr(int);

int netsl(char*,...);
int netslnb(char*,...);
int netslwt(int);
int netslpr(int);

int netslpr_assignment(int);
int netslwt_assignment(int,int*);
int netsl_assignment(char*,...);
int netslnb_assignment(char*,...);

int *netsl_farm(char*,...);

void    netsl_sequence_begin();     
int     netsl_sequence_end(void*,...);  
int     netsl_sequence_status();

int netslinit(char *agent);

void netsolvePerror(char*,int);
char *netsolveErrorMessage(int);


#endif

