/*****************************************************************/
/*      standardservice.h                                        */
/*      Henri Casanova                                           */
/*****************************************************************/

#ifndef __NS_STANDARDSERVICE_H
#define __NS_STANDARDSERVICE_H

#ifdef MULTINODESEQ
# include "ibp_base.h"
#endif

/**
 **  MACRO DEFINITIONS
 **/
#define FILES   0
#define NOFILES 1

/**
 **  FUNCTION PROTOTYPES
 **/
int solve(NS_ProblemDesc*,NS_Object**,NS_Object**);

int recvInputObjects(NS_Communicator*,NS_ProblemDesc*);
int readInputObjects(NS_ProblemDesc*);

int sendOutputObjects(NS_Communicator*,NS_ProblemDesc*,int);
int initOutputObjects(NS_ProblemDesc*);

#ifdef MULTINODESEQ
void forkStandardNoFileService(NS_Socket_type,char*,
                               char*,char*,int,int,char*,char*,
                               NS_ProblemDesc*,NS_IPaddr_type,int,
			       char*);
#else
void forkStandardNoFileService(NS_Socket_type,char*,
                               char*,char*,int,int,char*,char*,
                               NS_ProblemDesc*,NS_IPaddr_type,int);
#endif

void forkStandardFileService(NS_Socket_type,int,int,int,char*,char*,char*,int,int,
                         char*,char*,NS_ProblemDesc*,NS_IPaddr_type,int);

void forkStandardFileService_sequence(NS_Socket_type,int,int,int,char*,char*,char*,int,int,
				      char*,char*,NS_ProblemDesc*,NS_IPaddr_type,int,int,char*);

#ifdef MULTINODESEQ
void forkStandardService(NS_Socket_type,int,int,int,char*,char*,char*,int,int,
                         char*,char*,NS_ProblemDesc*,NS_IPaddr_type,int,int,int,char*);
#else
void forkStandardService(NS_Socket_type,int,int,int,char*,char*,char*,int,int,
                         char*,char*,NS_ProblemDesc*,NS_IPaddr_type,int,int,int);
#endif



#endif

