/* $Id: strutilTest.c,v 1.1 2000/03/10 21:10:46 susan Exp $ */

#include <stdio.h>
#include "strutil.h"

#define OUT1 "squid polyethylene"
#define OUT2 "bulbous and fast in bag"
#define OUT3 "bulbous and fast in bag                "
#define OUT4 "bulbo"
#define OUT5 "squid"

int main() {
	char buffer1[255];
	char buffer2[255];
	char buffer3[255];
	const char *carray[5] = {"bulbous", "and", "fast", "in", "bag"};
	int len;

	printf("Testing vstrncpy\n");
	len=vstrncpy(buffer1, 255, 3, "squid", " ", "polyethylene");
	if(strcmp(buffer1, OUT1)) {
		printf("Failed: %s / %s\n", buffer1, OUT1);
		return 1;
	} else if(len != strlen(buffer1)) {
		printf("Length mismatch: %d / %d\n", len, strlen(buffer1));
		return 1;
	} else {
		printf("Successful!\n");
	}

	printf("Testing strncpy_chararray\n");
	len = strncpy_chararray(buffer2, 255, 5, carray);
	if(strcmp(buffer2, OUT2)) {
		printf("Failed: %s / %s\n", buffer2, OUT2);
		return 1;
	} else if(len != strlen(buffer2)) {
		printf("Length mismatch: %d / %d\n", len, strlen(buffer2));
		return 1;
	} else {
		printf("Successful!\n");
	}

	printf("Testing strnpad\n");
	len+=strnpad(buffer2+len, 40-len, ' ');
	if(strcmp(buffer2, OUT3)) {
		printf("Failed: %s / %s (%d/%d)\n", 
			buffer2, OUT2, strlen(buffer2), strlen(OUT2));
		return 1;
	} else if(len != strlen(buffer2)) {
		printf("Length mismatch: %d / %d\n", len, strlen(buffer2));
		return 1;
	} else {
		printf("Successful!\n");
	}

	printf("Testing strncpy_chararray upper bound\n");
	len = strncpy_chararray(buffer3, 6, 5, carray);
	if(strcmp(buffer3, OUT4)) {
		printf("Failed: %s / %s\n", buffer3, OUT4);
		return 1;
	} else if(len != strlen(buffer3)) {
		printf("Length mismatch: %d / %d\n", len, strlen(buffer3));
		return 1;
	} else {
		printf("Successful!\n");
	}

	printf("Testing vstrncpy upper bound\n");
	len=vstrncpy(buffer1, 6, 3, "squid", " ", "polyethylene");
	if(strcmp(buffer1, OUT5)) {
		printf("Failed: %s / %s\n", buffer1, OUT5);
		return 1;
	} else if(len != strlen(buffer1)) {
		printf("Length mismatch: %d / %d\n", len, strlen(buffer1));
		return 1;
	} else {
		printf("Successful!\n");
	}

	printf("Testing strnpad 0\n");
    len+=strnpad(buffer1+len, 0, ' ');
	/* should remain unchanged from last test */
    if(strcmp(buffer1, OUT5)) {
        printf("Failed: %s / %s (%d/%d)\n",
            buffer1, OUT5, strlen(buffer1), strlen(OUT5));
        return 1;
    } else if(len != strlen(buffer1)) {
        printf("Length mismatch: %d / %d\n", len, strlen(buffer1));
        return 1;
    } else {
        printf("Successful!\n");
    }
	printf("Testing strnpad -1\n");
    len+=strnpad(buffer1+len, -1, ' ');
	/* should remain unchanged from last test */
    if(strcmp(buffer1, OUT5)) {
        printf("Failed: %s / %s (%d/%d)\n",
            buffer1, OUT5, strlen(buffer1), strlen(OUT5));
        return 1;
    } else if(len != strlen(buffer1)) {
        printf("Length mismatch: %d / %d\n", len, strlen(buffer1));
        return 1;
    } else {
        printf("Successful!\n");
    }


	return 0;
}

