/*****************************************************************/
/*      netslpr.c                                                */
/*      Version 1.0                      Henri Casanova          */
/*****************************************************************/



/*
 * fnetslpr() : FORTRAN interface 
 */

#include <stdarg.h>
#include "core.h"
#include "client.h"
#include "callingsequence.h"
#include "cfortranclient.h"
#include "mnemonics.h"


#ifdef ADD_
void fnetslpr_(int *request_id,int *info)
#endif
#ifdef UPCASE
void FNETSLPR(int *request_id,int *info)
#endif
#ifdef NOCHANGE
void fnetslpr(int *request_id,int *info)
#endif
{
  int status;

  if (requests[*request_id] == NULL)
  {
    *info = NetSolveInvalidRequestID;
    return;
  }

  status = netsolveProbeRequest(&(requests[*request_id]));

  if (ns_errno == NetSolveNotReady)
  {
    *info = NetSolveNotReady;
    return;
  }

  if (status == -1)
  {
    freeProblemDesc(requests[*request_id]->pd);
    free(output_ptrs[*request_id]);
    freeRequestDesc(requests[*request_id]);
    requests[*request_id] = NULL;
    output_ptrs[*request_id] = NULL;
    *info = ns_errno;
    return;
  }
 
  *info = NetSolveOK;
  return;
}

