/*****************************************************************/
/*      netslwt.c                                                */
/*      Version 1.0                      Henri Casanova          */
/*****************************************************************/



/*
 * fnetslwt() : FORTRAN interface 
 */

#include <stdarg.h>
#include "core.h"
#include "client.h"
#include "callingsequence.h"
#include "cfortranclient.h"
#include "mnemonics.h"


#ifdef ADD_
void fnetslwt_(int *request_id,int *info)
#endif
#ifdef UPCASE
void FNETSLWT(int *request_id,int *info)
#endif
#ifdef NOCHANGE
void fnetslwt(int *request_id,int *info)
#endif
{
  int status;
  int elapsed;

  if (requests[*request_id] == NULL)
  {
    *info = NetSolveInvalidRequestID;
    return;
  }

  status = netsolveWaitRequest(&(requests[*request_id]),&elapsed);

  if (status != -1)
  {
    int i;

    /* take output_ptrs of the strings in output */
    for (i=0;i<requests[*request_id]->pd->nb_output_objects;i++)
    {
      if (requests[*request_id]->pd->output_objects[i]->object_type != NETSOLVE_STRING)
        continue;
      strcpy(output_ptrs[*request_id][i],
        requests[*request_id]->pd->output_objects[i]->attributes.string_attributes.ptr); 
     free(requests[*request_id]->pd->output_objects[i]->attributes.string_attributes.ptr);
    }
    /* take care of the strings in input */
    for (i=0;i<requests[*request_id]->pd->nb_input_objects;i++)
    {
      if(!isStringArgument(requests[*request_id]->pd,requests[*request_id]->pd->calling_sequence->arg_to_mnemonic[i]))
        continue;
      switch(requests[*request_id]->pd->input_objects[i]->object_type)
      {
        case NETSOLVE_STRING:
          free(requests[*request_id]->pd->input_objects[i]->attributes.string_attributes.ptr);
          break;
      }
    }
    ns_errno = NetSolveOK;
  }
  freeProblemDesc(requests[*request_id]->pd);
  free(output_ptrs[*request_id]);
  freeRequestDesc(requests[*request_id]);
  requests[*request_id] = NULL;
  output_ptrs[*request_id] = NULL;
  *info = ns_errno;
  return;
}

