/*****************************************************************/
/*      netslinit.c                                              */
/*      Version 1.0                      Henri Casanova          */
/*---------------------------------------------------------------*/
/*  netslinit()                                                  */
/*****************************************************************/

/*
 * netslinit() : does a few useful initializations
 */

#include <stdarg.h>
#include <unistd.h>
#include "core.h"
#include "client.h"
#include "mnemonics.h"
#include "callingsequence.h"
#include "cfortranclient.h"
#include "proxy.h"

int netslinit(char *agent)
{
  char *agent_name;

#ifndef NO_OUTPUT
  fprintf(stderr,"pid %i Initializing NetSolve...\n", getpid());
#endif

  /* Get the agent name */
  if (agent == NULL)
  {  /* Get it from the environment */
    agent_name = getNetSolveAgent();
    if (agent_name == NULL)
    {
      ns_errno = NetSolveSetNetSolveAgent;
      return ns_errno;
    }
  }
  else 
    agent_name = strdup(agent);

#ifdef DEBUG
  fprintf (stderr, "agent name = %s\n", agent_name);
#endif

  /* Get the data format */
  my_data_format = getArch();
  if (my_data_format == -1)
  {
    ns_errno = NetSolveSetNetSolveArch;
    return ns_errno;
  }

  /* Start the proxy !!                         */
  /* proxy_pid, proxy_port are global variables */

#ifdef DEBUG
  fprintf (stderr, "Calling startProxy...\n");
#endif

  if (startProxy("NetSolve",agent_name,&proxy_pid,&proxy_port) == -1) { 
    fprintf (stderr, "Error return from startProxy = %d\n", ns_errno);
    return ns_errno;
  }
 
#ifdef DEBUG
  fprintf (stderr, "Successful return from startProxy...\n");
#endif
  return NetSolveOK;
}
