/*****************************************************************/
/*      netslpr.c                                                */
/*      Henri Casanova          				 */
/*---------------------------------------------------------------*/
/*  netslpr()                                                    */
/*****************************************************************/

/*
 * netslpr() : vararg C Interface to the NetSolve Client
 */

#include <stdarg.h>
#include "core.h"
#include "client.h"
#include "callingsequence.h"
#include "cfortranclient.h"
#include "mnemonics.h"

int netslpr(int request_id)
{
  int status;
 
  if (requests[request_id] == NULL)
    return NetSolveInvalidRequestID;

  status = netsolveProbeRequest(&(requests[request_id]));

  if (ns_errno == NetSolveNotReady)
    return ns_errno;

  if (status == -1)
  {
    freeProblemDesc(requests[request_id]->pd);
    free(output_ptrs[request_id]);
    freeRequestDesc(requests[request_id]);
    requests[request_id] = NULL;
    output_ptrs[request_id] = NULL;
    return ns_errno;
  }

  ns_errno = NetSolveOK;
  return ns_errno;
}
