/*****************************************************************/
/*      CP_retirejob.c                                           */
/*      Jakob Oestergaard                                        */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include "core.h"
#include "client.h"
#include "client2proxy.h"
#include "proxyjobdesc.h"
#include "proxy.h"

#include <signal.h>
#include <time.h>

/*
 *  CP_retireJob()
 *
 * We send a NS_PROT_RM_JOB_DESC to the proxy to let
 * it know tat the given ID is no longer in use by us.
 */
int CP_retireJob(NS_RequestDesc *rd)
{
  NS_Communicator *comm;

  /********************************************/
  /* contact the proxy 			      */
  /********************************************/
  comm = contactProxy(1);
  if (comm == NULL)
  {
    netsolvePerror(__FILE__,__LINE__);
    ns_errno = NetSolveProxyError;
    return -1;
  } 

  /* Sending */
  if ((sendInt(comm,NS_PROT_RM_JOB_DESC) == -1)              ||
      (sendInt(comm,rd->request_id) == -1))
  {
    netsolvePerror(__FILE__,__LINE__);
    endTransaction(comm);
    ns_errno = NetSolveProxyError;
    return -1;
  }

  endTransaction(comm);

  ns_errno = NetSolveOK;
  return 1;
}
