/*****************************************************************/
/*      netsolveblocking.c                                       */
/*      Henri Casanova                                           */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include "core.h"
#include "client.h"

/*
 * netsolveBlocking()
 *
 * This function allows the user to perform a synchronous computation.
 * It returns either an error code, or with the result in the user's
 * workspace. This function is build on top of two other functions
 * that are also part of the client interfaceimplemented in this
 * directory.
 */
int netsolveBlocking(NS_ProblemDesc *pd,NS_Object **input,NS_Object **output,
                     int *elapsed)
{
  int status;
  NS_RequestDesc *rd;

  /***********************************/
  /* Sending an asynchronous request */
  /***********************************/

  rd = netsolveSendRequest(pd,input,output);
  if (rd == NULL)
    return -1;

  /****************************/
  /* Waiting for that request */
  /****************************/

  status = netsolveWaitRequest(&rd,elapsed);

  free(rd);
  return status;
}
