/*****************************************************************/
/*      netsolveblocking_assignment.c                            */
/*      Henri Casanova                                           */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include "core.h"
#include "client.h"

/*
 * netsolveBlockingAssignment()
 *
 * This function is identical to netsolveBlocking, but it takes
 * an IPaddr in input (since it's an job *assignment*), and does
 * not automatically resubmit in case of an error.
 */
int netsolveBlockingAssignment(NS_IPaddr_type IPaddr,
                NS_ProblemDesc *pd,NS_Object **input,NS_Object **output,
                     int *elapsed)
{
  int status;
  NS_RequestDesc *rd;

  /***********************************/
  /* Sending an asynchronous request */
  /***********************************/

  rd = netsolveSendAssignment(pd,input,output,IPaddr);
  if (rd == NULL)
    return -1;

  /****************************/
  /* Waiting for that request */
  /****************************/

  status = netsolveWaitAssignment(&rd,elapsed);

  free(rd);
  return status;
}
