/*****************************************************************/
/*      netsolvesendrequest.c                                    */
/*      Henri Casanova                                           */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include "core.h"
#include "client.h"
#include "client2proxy.h"
#include "client2server.h"
#include <signal.h>
#include <time.h>

/*
 * netsolveSendAssignment()
 *
 * This function sends an asynchronous assignment to the NetSolve system.
 */
NS_RequestDesc *netsolveSendAssignment(NS_ProblemDesc *pd,NS_Object **input,
          NS_Object **output,NS_IPaddr_type IPaddr)
{
  NS_RequestDesc *rd;

  /********************************************/
  /* Try sending a request to the system      */
  /* until is works                           */
  /********************************************/
  rd = newRequestDesc();
  while(1)
  {
    rd = CP_sendJobAssignment(pd,IPaddr);
    if (rd == NULL)
      return NULL;
    /* Add the local information */
    rd->input = input;
    rd->output = output;

    /* Send the input */
    if (CS_sendInput(rd) == -1)
    {
       if (ns_errno == NetSolveFileError) {
         free(rd);
	 return NULL;
       }

       reportFailure(rd->IPaddr,rd->pd->nickname,
                     rd->request_id,HOST_ERROR, rd->pd->job_id);
    }
    else
      break;
  }

  ns_errno = NetSolveOK;
  return rd;
}
