
BeginPackage["NetSolve`"]
NetSolve::usage = "usage: NetSolve[FuncName[arg1, ...]]    - blocking problem call
                          NetSolveNB[FUNCNAME[arg1, ...]] - nonblocking problem call
                          NetSolve[\\\"?problems\\\"]            - shows a list of available problems
                          NetSolve[\\\"?servers\\\"]             - shows a list of available servers
                          NetSolve[\\\"?FuncName[]\\\"]          - shows a problem description"
			  
Begin["`Private`"]

ClearAll["NetSolve*"];

NSMATH = Environment["NETSOLVE_ROOT"];
If[StringQ[NSMATH], 
   Null,
   (Print["Please setup NETSOLVE_ROOT environment variable to point the directory where the NetSolve is installed"];
      Return[]
   )
  ];
  
NSARCH = Environment["NETSOLVE_ARCH"];
If[StringQ[NSARCH], 
    Null, 
   (Print["Please setup NETSOLVE_ARCH environment variable"];
     Return[])
  ];
       
NSMATHFILE = NSMATH <> "/bin/" <> NSARCH <> "/ns_math";
If[ ToString[FileType[NSMATHFILE]] != "File",
   ( Print[NSMATHFILE, " not found."];
      Print["Did you compile it for your platform successfully?"]),
   nsmathlink = Install[NSMATHFILE]
  ];

End[] 
EndPackage[]
