/**
* SecondFrame
*
* This class controls the graphical user interface for the Initial
* Screen.
* 
* @version 1.1, 26 Jan 1998 
* @author Henri Casanova (casanova@cs.utk.edu)
*
**/

import java.awt.*;
import java.awt.event.*;

abstract class IncLib extends OkayFrame
 {

  TextArea area1;
  TextArea area2;
  Panel label1Panel;
  Panel label2Panel;

  GridBagLayout gridbag;
  GridBagConstraints c;

  static final int LABEL_FONT_SIZE    = 14;

  /**
   * 
   * This is the constructor for the SecondFrame class.  The purpose of
   * this method is to initialize and layout all the graphical components 
   * in the Initial Screen.  This is all done with standard AWT components.
   * 
   * @param f The parent frame.
   *
   **/

  public IncLib(String title) {
  
    super(title);

    /* Take care of the top panel */
    gridbag = new GridBagLayout();
    c = new GridBagConstraints();
    topPanel.setLayout(gridbag);

    label1Panel = new Panel();
    label1Panel.setLayout(new GridLayout(1,1));
    area1 = new TextArea("", 5,  40, TextArea.SCROLLBARS_VERTICAL_ONLY);
    area1.setEditable(true);

    label2Panel = new Panel();
    label2Panel.setLayout(new GridLayout(1,1));
    area2 = new TextArea("", 5,  40, TextArea.SCROLLBARS_VERTICAL_ONLY);
    area2.setEditable(true);

    /*c.weightx = 1.0; */
    c.gridwidth = GridBagConstraints.REMAINDER;
    c.anchor = GridBagConstraints.WEST;
    gridbag.setConstraints(label1Panel, c);
    topPanel.add(label1Panel);
    gridbag.setConstraints(area1, c);
    topPanel.add(area1);
    gridbag.setConstraints(label2Panel, c);
    topPanel.add(label2Panel);
    gridbag.setConstraints(area2, c);
    topPanel.add(area2);

    this.pack();
  }

}

