/**
* NetSolveClient
*   
* This is the 'main' class in the Java interface.  It pops up
* the main screen
* 
* @version 1.1, 26 Jan 1998
* @author Henri Casanova (casanova@cs.utk.edu)
*
**/

import java.applet.*;

public class PDGUI extends Applet {

  public HelpFrame helpFrame;
  public DescriptionFrame descriptionFrame;
  public DefinitionFrame definitionFrame;
  public InOutFrame inoutFrame;
  public MatlabCallFrame matlabCallFrame;
  public CFCallFrame cfCallFrame;
  public CodeFrame codeFrame;
  public ToolBox toolBox;
  public FunctionFrame functionFrame;
  public Miscellaneous misc;

  public StatusObject statusObject;
  public ProblemDescription problemDescription;
  
  public static boolean inApplet = true;

  /**
   *
   * This is the constructor for the PDGUI class.
   * It initializes the Initial Screen.
   * 
   **/

  public PDGUI(){
    problemDescription = new ProblemDescription();
    statusObject = new StatusObject();

    helpFrame = new HelpFrame(this);
    descriptionFrame = new DescriptionFrame(this);
    definitionFrame = new DefinitionFrame(this);
    inoutFrame = new InOutFrame(this);
    matlabCallFrame = new MatlabCallFrame(this);
    cfCallFrame = new CFCallFrame(this);
    codeFrame = new CodeFrame(this);
    toolBox = new ToolBox(this);
    functionFrame = new FunctionFrame(this);
    misc = new Miscellaneous(this);

    descriptionFrame.setVisible(true);
  } // End PDGUI

  /**
   *
   * This is the first method called when the interface is
   * started from the command line (e.g. java PDGUI).
   * It creates a new instance of PDGUI
   * causing the constructor to be called.
   * 
   * @param argv The array of command line parameters.
   *
   **/

  public static void main(String argv[]){
    
    inApplet = false;

    PDGUI f = new PDGUI();
  } // End main

} // end class NetSolveClient
