/*****************************************************************/
/*      waitforproxytocomeup.c                                   */
/*      Henri Casanova                                           */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include "core.h"
#include "client.h"
#include "proxyjobdesc.h"
#include "proxy.h"
#include "lifelink.h"
#include <signal.h>
#include <unistd.h>

#define PROXY_TIMEOUT 10

/*
 * Wait for the proxy to come up
 * and starts the life-link !!!
 */
int waitForProxyToComeUp()
{
  NS_Communicator *comm;
  int i;

#ifdef DEBUG
/*    fprintf (stderr, "startProxy parent calls waitForProxyToComeUp()\n"); */
#endif
  for (i=0;i<PROXY_TIMEOUT;i++)
  {

#ifdef DEBUG
/*    fprintf (stderr, "waitForProxyToComeUp(): attempt to contactProxy()\n"); */
#endif
    comm = contactProxy(0);
    if (comm != NULL)
    {

#ifdef DEBUG
  fprintf (stderr, "waitForProxyToComeUp(): contactProxy() succeeded!\n");
#endif
      if (sendInt(comm,NS_PROT_JUST_CHECKING) != -1)
      {
        if (startLifeLink(getMyIPaddr(),proxy_port,NS_PROT_DIE,0,0) == -1)
        {
          netsolvePerror(__FILE__,__LINE__);
          fprintf(stderr, "Cannot start life link to proxy\n");
          return -1;
        }
        endTransaction(comm);
        return 1;
      }
    }
    sleep(1);
  }
#ifdef DEBUG
  fprintf(stderr, "Proxy timeout !!\n");
#endif
  return -1;
}
