include $(NETSOLVE_ROOT)/conf/$(NETSOLVE_ARCH).def
include $(NETSOLVE_ROOT)/src/SampleNumericalSoftware/SparseSolvers/Makefile.env

CLINKER = gcc

DEBUG_SWITCH = no
DEBUG_yes = DEBUG
DEBUG_no = nodebug
COPT_FLAGS_yes =
COPT_FLAGS_no = 
C_OPT_FLAGS = -O2
GLOBAL_CFLAGS = \
	$(C_OPT_FLAGS) -D$(DEBUG_$(DEBUG_SWITCH)) $(DEFINEDS) \
	-I. -I$(NETSOLVE_SPARSE_DIR) $(PETSC_INCLUDES) $(MPI_INCLUDES)

libdir :
	@cd $(NETSOLVE_SPARSE_DIR)/lib ; \
	    if [ ! -x $(NETSOLVE_ARCH) ] ; then \
	      mkdir $(NETSOLVE_ARCH) ; \
	    fi
deletelibs ::
	@/bin/rm -f $(NETSOLVE_$(COMPONENT)_LIB)
$(NETSOLVE_$(COMPONENT)_TESTER_FILES) : \
    $(NETSOLVE_SPARSE_DIR)/test/setup.c \
    $(NETSOLVE_SPARSE_DIR)/test/declarations.c \
    $(NETSOLVE_SPARSE_DIR)/test/unset.c

NETSOLVE_SPARSE_LIB_DIR = $(NETSOLVE_SPARSE_DIR)/lib/$(NETSOLVE_ARCH)
NETSOLVE_AZTEC_DIR = $(NETSOLVE_SPARSE_DIR)/aztec
NETSOLVE_ITPACK_DIR = $(NETSOLVE_SPARSE_DIR)/itpack
NETSOLVE_MA28_DIR = $(NETSOLVE_SPARSE_DIR)/ma28
NETSOLVE_PETSC_DIR = $(NETSOLVE_SPARSE_DIR)/petsc
NETSOLVE_SUPERLU_DIR = $(NETSOLVE_SPARSE_DIR)/superlu
NETSOLVE_DRIVER_DIR = $(NETSOLVE_SPARSE_DIR)/driver
NETSOLVE_AUX_DIR = $(NETSOLVE_SPARSE_DIR)/aux
NETSOLVE_TEST_DIR = $(NETSOLVE_SPARSE_DIR)/test

MORE_LIBS_sun4 = -static \
	/usr/lang/SC2.0.1/libF77.a /usr/lang/SC2.0.1/libM77.a \
	-lm /usr/lang/SC2.0.1/libm.a
MORE_LIBS_linux = -ldl -lc $(F2C_LIB_LINK) -lm
MORE_LIBS_solaris = -L/opt/SUNWspro/SC4.0/lib \
	-lnsl -lsocket -lgen -lM77 -lF77 -lsunmath -lm
MORE_LIBS = \
    $(PETSC_LIB_LINK) $(MPI_LIB_LINK) $(LAPACK_LIB_LINK) $(BLAS_LIB_LINK) \
    $(MORE_LIBS_$(PETSC_ARCH)) 
