#include <stdlib.h>
#include <stdio.h>
#include "mpi.h"
#include "error_returns.h"
#include "az_aztec.h"
#include "./aztec_auxs.h"
#include "./aztec_impl.h"
#include "driver/sparse.h"
#ifdef DEBUG
#include "matrix_auxs.h"
#endif

int aztec_params(direct_info_block *info,double rtol,int maxit)
{
  aztec_info_block aztec_info;

  aztec_info = (aztec_info_block) malloc
    (sizeof(struct aztec_info_block_));
  aztec_info->rtol = rtol; aztec_info->maxit = maxit;
  *info = (direct_info_block) aztec_info;

  return 0;
}

int aztec_set_return_params(iterative_info_block info,int conv,int its)
{
  aztec_info_block aztec_info = (aztec_info_block) info;

  aztec_info->conv = conv; aztec_info->its = its;

  return 0;
}

int aztec_get_return_params(iterative_info_block info,int *conv,int *its)
{
  aztec_info_block aztec_info = (aztec_info_block) info;

  *conv = aztec_info->conv; *its = aztec_info->its;

  return 0;
}

void aztec_get_vecsizes(int *data_org,int *insize,int *outsize)
{
  *insize = data_org[AZ_N_internal]+data_org[AZ_N_border];
  *outsize = data_org[AZ_N_internal]+data_org[AZ_N_border]
    +data_org[AZ_N_external];

  return;
}
