/*
 * driver and computational routines for interfacing aztec to netsolve
 */
#include "../driver/sparse.h"
#include "mpi.h"

extern int aztec_params(iterative_info_block *info,double rtol,int maxit);
extern int aztec_set_return_params
(iterative_info_block info,int conv,int its);
extern int aztec_get_return_params
(iterative_info_block info,int *conv,int *its);

/* Iterative matrix solution */
extern int aztec_iterative_driver
(MPI_Comm comm,
 double *values,int *indices,int *pointers,
 int first,int local_size,
 double *rhs_vector,double *sol_vector,
 iterative_info_block info);

/* Matrix vector product */
extern int aztec_matprod
(MPI_Comm comm,
 double *mat_el,double *x_el,
 int first,int last,
 int nnzero,
 int *idx,
 double *return_vec_el
 );
