/*
 * tester for the Itpack iterative solver
 */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "mpi.h"
#include "sparse_globals.h"
/* general Itpack includes */
#include "itpack.h"
#include "itpack_auxs.h"
/* specific include for this test */
#include "sparse_auxs.h"
#include "matrix_auxs.h"
#include "./netsolve_itpack.h"

int main(int Argc,char **Args)
{
int i;
#include "../test/declarations.c"
  iterative_info_block info; double rtol; int maxit;

#include "../test/setup.c"
  /*printf("values:\n");
  for(i=0; i<nnzeros; i++)
    printf("%f ", values[i]);
  printf("\n");
  printf("indices:\n");
  for(i=0; i<nnzeros; i++)
    printf("%d ", indices[i]);
  printf("\n");
  printf("ptr:\n");
  for(i=0; i<total_size; i++)
    printf("%d ", pointers[i]);
  printf("\n");
  printf("rhs:\n");
  for(i=0; i<local_size; i++)
    printf("%f ", rhs_vector[i]);
  printf("\n"); */


  ierr = crs_mat_tobase1(values,indices,pointers,local_size); ERR_RETURN(ierr);
  first++;
  if (mytid==0) {
    printf("Relative tolerance : "); scanf("%lf",&rtol); printf("\n");
    printf("Maximum #iterations : "); scanf("%d",&maxit); printf("\n");
  }
  MPI_Bcast(&rtol,1,MPI_DOUBLE,0,comm);
  MPI_Bcast(&maxit,1,MPI_INT,0,comm);

  ierr = itpack_params(&info,rtol,maxit); ERR_RETURN(ierr);

  printf("value: %f\n", values[0]);
  printf("ind: %d\n", indices[0]);
  printf("ptrs: %d\n", pointers[0]);
  printf("first: %d\n", first);
  printf("size: %d\n", local_size);
  printf("rhs: %f\n", rhs_vector);
  ierr = itpack_iterative_driver
    (MPI_COMM_WORLD,
     values,indices,pointers, first,local_size,
     rhs_vector,sol_vector,
     info); ERR_RETURN(ierr);

  ierr = itpack_get_return_params(info,&conv,&its); ERR_RETURN(ierr);
  if (mytid==0)
    if (conv) {
      printf("The method converged in %d iterations\n",its);
    } else {
      printf("No convergence in the number of iterations specified\n");
    }

    printf("solution:\n");
    for(i=0; i<local_size; i++)
       printf("%f ", sol_vector[i]);
    printf("\n");
  
  ierr = crs_mat_tobase0(values,indices,pointers,local_size); ERR_RETURN(ierr);
#include "../test/unset.c"
  free(info);

  return 0;
}
