/*
 * driver and computational routines for interfacing aztec to netsolve
 */
#include "../driver/sparse.h"
#include "mpi.h"

extern int petsc_params
(iterative_info_block *info,double rtol,int maxit,double atol,double dtol);
extern int petsc_set_return_params
(iterative_info_block info,int conv,int its);
extern int petsc_get_return_params
(iterative_info_block info,int *conv,int *its);

/* Iterative matrix solution */
extern int petsc_iterative_driver
(int Argc,char **Args, MPI_Comm comm,
 int first,int local_size,
 double *values,int *indices,int *pointers,
 double *rhs_vector,double *solution_vector,
 iterative_info_block info);

/* Matrix times vector product */
extern int petsc_matprod
(MPI_Comm comm,
 double *mat_el,double *x_el,
 int local,int nnzero,
 int *idx,int *pointers,
 double *return_vec_el
 );

/* Direct matrix solution */
extern int petsc_sparse_direct_solve
(MPI_Comm comm,
 double *mat_el,double *x_el,
 int isize,int jsize,int Isize,int Jsize,int nnzero,
 int *idx,int *pointers,
 double *return_vec_el
 );
