%/*****************************************************************/
%/*      scalapack_test.m                                         */
%/*      Susan Blackford                                          */
%/*---------------------------------------------------------------*/
%/*****************************************************************/

fprintf(2, '---------------------------------------------------\n')
fprintf(2, 'Testing the NetSolve MATLAB ScaLAPACK interfaces...\n')
fprintf(2, '---------------------------------------------------\n')
fprintf(2, ' \n')
fprintf(2, '---------------------------------------------------\n')
fprintf(2, 'Testing Simple Driver routines for Linear Equations\n')
fprintf(2, '---------------------------------------------------\n')
fprintf(2, '\n** Sending a blocking request for "pdgesv"\n\n')
count = 0;
failcount = 0;
n=50;
a=rand(50);
b=rand(50,1);
[x,z,info]=netsolve('pdgesv',a,b);
r=norm(a*z-b)/(norm(a)*norm(z)*n*eps);
[e] = netsolve_err;
count = count + 1;
if (e ~= 0 | info ~= 0 | r > 50.0 )
  fprintf(2,'%s\n',netsolve_errmsg(e))
  fprintf(2, '** PDGESV Failure **')
  r
  failcount = failcount + 1;
end

fprintf(2, '\n** Sending a blocking request for "pdposv"\n\n') 
clear N C B A A1 X info r1
N=20;
C=rand(N);
B=rand(N,5);
A=C*C';
[A1,X,info]=netsolve('pdposv','U',A,B);
r1=norm(A*X-B)/(norm(A)*norm(X)*N*eps);
[e] = netsolve_err;
count = count + 1;

if (e ~= 0 | info ~= 0 | r1 > 50.0 )
  fprintf(2,'%s\n',netsolve_errmsg(e))
  fprintf(2, '** PDPOSV(U) Failure **')
  r1
  failcount = failcount + 1;
end

clear N C B A A1 X info
N=20;
C=rand(N);
B=rand(N,5);
A=C*C';
[A1,X,info]=netsolve('pdposv','L',A,B);
r2=norm(A*X-B)/(norm(A)*norm(X)*N*eps);
[e] = netsolve_err;
count = count + 1;

if (e ~= 0 | info ~= 0 | r2 > 50.0 )
  fprintf(2,'%s\n',netsolve_errmsg(e))
  fprintf(2, '** PDPOSV(U) Failure **')
  r1
  failcount = failcount + 1;
end

fprintf(2, '\n ** %d Tests were performed.\n', count)
fprintf(2, '\n ** %d tests failed to pass the threshold.\n\n', failcount)


fprintf(2, '       ** End of testing **\n\n');

pause(1);
