/*-----------------------------------------------*/
/*-----------------------------------------------*/
/* Includes, constants and macros for the progam */
/*-----------------------------------------------*/
#include "core.h"
#include "mnemonics.h"
#include "client.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
/*#include <ndbm.h>*/
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <ctype.h>
#include "libcgi/cgi.h"
#include "netsolve_util.h"

#define MAXAGENTPARTS  5
#define MAXSERVERPARTS  25
#define MAXPARTLENGTH 250

/*----------------------------------------*/
/* Mostly stub routine from cgi-lib files */
/*----------------------------------------*/

int postResponse (char *);

int cgi_main(cgi_info *ci) {
  char *parmval(form_entry *, char *);
  form_entry *parms, *p;
  form_entry *get_form_entries(cgi_info *);
  char *agent;
  int ftime(struct timeb* tp);
  struct timeb tb;
  double t1, t2;

  ftime(&tb);
  t1 = (double)(tb.time)+(double)tb.millitm/1000;

  print_mimeheader("text/html");

  parms = get_form_entries(ci);
  if (parms) {
    /* extract specific form parameters */
    for(p=parms; p; p = p->next) {
      if (!strcasecmp(p->name, "agent")) agent = p->val;
    }
  }

  puts("<html> <head>");
  puts("<title>NetSolve Hardware Resources Graphical View</title>");
  puts("</head> <body BGCOLOR=#771122 text=yellow link=orange vlink=orange>");
  puts("<center><h1>NetSolve System</h1></center>");
  fprintf(stdout,"<center><h2>as seen by '<tt>%s</tt>'</h2></center>",
        agent);

  postResponse(agent);

  free_form_entries(parms);
  ftime(&tb);
  t2 = (double)(tb.time)+(double)tb.millitm/1000;
  puts("<center>");
  printf("<h4><hr>Elapsed wall-clock time: %f sec<br><hr>\n",t2-t1);
  puts("<a href=../resources.html>Back to Netsolve Resources</a>");
  puts("</center>");
  puts("</body> </html>");

  return 0;
}


int postResponse( char *agent)
{
  NS_ServerDesc **server_list;
  NS_AgentDesc **agent_list;
  int nb_servers;
  int nb_agents;
  int i;
  int max_param_count, param_count, current_len, temp_len;
  char temp_str[255];

  puts("<center>");
  puts("<APPLET  CODE=\"netsolve_view.class\" \
  WIDTH=500 HEIGHT=800>\n");

  nb_agents = get_agent_list(&agent_list, agent);
  max_param_count = MAXAGENTPARTS;
  param_count = 1;
  /* Error */
  if (nb_agents == -1)
  {  
   for(i=param_count;i<=max_param_count;i++) {
        fprintf(stdout,"<PARAM NAME=AGENTPART%d VALUE=\"\">\n",i);
   }
   max_param_count = MAXSERVERPARTS;
   param_count = 1;
   for(i=param_count;i<=max_param_count;i++) {
        fprintf(stdout,"<PARAM NAME=SERVERPART%d VALUE=\"\">\n",i);
   }
   puts("</APPLET>");
   printf("<h2>%s</h2>",netsolveErrorMessage(ns_errno));
   return 0;
  }

  /* sorting the list */
  qsort(agent_list,nb_agents,sizeof(NS_AgentDesc *),agentOrder);

  /* Printing the list */
  current_len = 0;
  fprintf(stdout,"<PARAM NAME=AGENTPART%d VALUE=\"",param_count);

  for (i=0;i<nb_agents;i++)
  {
    sprintf(temp_str,"%s|",
                        agent_list[i]->host_desc->hostname);
    temp_len = strlen(temp_str);
    if ((temp_len + current_len) > MAXPARTLENGTH) {
	fprintf(stdout,"\">\n");
	current_len = temp_len;
	param_count++;
	fprintf(stdout,"<PARAM NAME=AGENTPART%d VALUE=\"%s",param_count,temp_str);
    } else {
	current_len += temp_len;
	fprintf(stdout,"%s",temp_str);
    }
  }

  fprintf(stdout,"\">\n");
  param_count++;

  for(i=param_count;i<=max_param_count;i++) {
	fprintf(stdout,"<PARAM NAME=AGENTPART%d VALUE=\"\">\n",i);
  }

  for (i=0;i<nb_agents;i++)
    freeAgentDesc(agent_list[i]);
  free(agent_list);

  nb_servers = get_server_list(&server_list, agent);
  max_param_count = MAXSERVERPARTS;
  param_count = 1;
  /* Error */
  if (nb_servers == -1)
  {
   for(i=param_count;i<=max_param_count;i++) {
        fprintf(stdout,"<PARAM NAME=SERVERPART%d VALUE=\"\">\n",i);
   }
   puts("</APPLET>");
   printf("<h2>%s</h2>",netsolveErrorMessage(ns_errno));
   return 0;
  }

  /* sorting the list */
  qsort(server_list,nb_servers,sizeof(NS_ServerDesc *),serverOrder);
  /* Printing the list */
  max_param_count = MAXSERVERPARTS;
  param_count = 1;
  current_len = 0;
  fprintf(stdout,"<PARAM NAME=SERVERPART%d VALUE=\"",param_count);


  for (i=0;i<nb_servers;i++)
  {
    sprintf(temp_str,"%s|",
                           server_list[i]->host_desc->hostname);
    temp_len = strlen(temp_str);
    if ((temp_len + current_len) > MAXPARTLENGTH) {
        fprintf(stdout,"\">\n");
        current_len = temp_len;
        param_count++;
        fprintf(stdout,"<PARAM NAME=SERVERPART%d VALUE=\"%s",param_count,temp_str);
    } else {
        current_len += temp_len;
        fprintf(stdout,"%s",temp_str);
    } 
  }

  fprintf(stdout,"\">\n");  
  param_count++;
    
  for(i=param_count;i<=max_param_count;i++) {
        fprintf(stdout,"<PARAM NAME=SERVERPART%d VALUE=\"\">\n",i);
  }
  
  for (i=0;i<nb_servers;i++)
    freeServerDesc(server_list[i]);
  free(server_list);
  
  puts("</APPLET>");
  puts("</center>");
 
  return 1;
}
