/*-----------------------------------------------*/
/* Includes, constants and macros for the progam */
/*-----------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
/* #include <ndbm.h> */
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <ctype.h>
#include "libcgi/cgi.h"
#include "core.h"
#include "mnemonics.h"
#include "client.h"
#include "netsolve_util.h"

void printMnemonicSemantic(NS_ProblemDesc*,char*);
void printCFortranCallingSequence(NS_ProblemDesc*);
void printMnemonicSemantic(NS_ProblemDesc*,char*);
void displayObject(NS_Object*);

int postResponse(char *);
/*----------------------------------------*/
/* Mostly stub routine from cgi-lib files */
/*----------------------------------------*/

int cgi_main(cgi_info *ci) {
  char *parmval(form_entry *, char *);
  form_entry *parms, *p;
  form_entry *get_form_entries(cgi_info *);
  char *agent;
  int ftime(struct timeb* tp);
  struct timeb tb;
  double t1, t2;

  ftime(&tb);
  t1 = (double)(tb.time)+(double)tb.millitm/1000;

  print_mimeheader("text/html");
  parms = get_form_entries(ci);
  if (parms) {
    /* extract specific form parameters */
    for(p=parms; p; p = p->next) {
      if (!strcasecmp(p->name, "agent")) agent = p->val;
    }
  }

  agent=strdup("bluegrass");
  puts("<html> <head>");
  puts("<title>NetSolve Hardware Resources</title>");
  puts("</head> <body BGCOLOR=#771122 text=yellow link=orange vlink=orange>");
  puts("<center><h1>NetSolve System</h1></center>");
  fprintf(stdout,"<center><h2>as seen by '<tt>%s</tt>'</h2></center>",
        agent);
  puts("<br><hr width = 500 ><br>\n");

  postResponse(agent);

  free_form_entries(parms);
  ftime(&tb);
  t2 = (double)(tb.time)+(double)tb.millitm/1000;
  puts("<center>");
  printf("<h4><hr>Elapsed wall-clock time: %f sec<br><hr>\n",t2-t1);
  puts("<a href=../test.html>Back to Netsolve Resources</a>");
  puts("</center>");
  puts("</body> </html>");

  return 0;
}


int postResponse(char *agent)

{
  NS_ProblemDesc **problem_list;
  NS_ProblemDesc *pd;
  int nb_problems;
  int i;
  int j;
  char *cp;
  char a[100][50];

   
  nb_problems = get_problem_list(&problem_list, agent);

  /* Error */
  if (nb_problems == -1)
  {
    fprintf(stdout,"<center><h2>%s</h2></center>",
            netsolveErrorMessage(ns_errno));
    return -1;
  }

  /* No problems */
  if (nb_problems == 0)
  {
    puts("<center><h2>NO PROBLEMS</h2></center>");
    return -1;
  }

  /* sorting the list */
  qsort(problem_list,nb_problems,sizeof(NS_ProblemDesc *),problemOrder);

  /* Printing the list */
  puts("<center>");
  puts("<h2>PROBLEM LIST</h2>");
  puts("<table border=2>");

  for (i=0;i<nb_problems;i++)
  {
    j=0;
    fprintf(stdout,"<tr><td><A href=#%s>%s</A></td></tr>\n",                                problem_list[i]->name,problem_list[i]->name);

    strcpy(a[i],strrchr(problem_list[i]->name,'/'));
    do{  a[i][j]=a[i][j+1]; j++;} 
    while(a[i][j]!=0);
  }
  puts("</table>");
  for (i=0;i<nb_problems;i++)
    freeProblemDesc(problem_list[i]);
  free(problem_list);
  puts("<br>");
  puts("<br>");

 for(i=0;i<nb_problems;i++)
 {
  if (get_problem(a[i],&pd, agent)==-1){
    fprintf(stdout,"<center><h2>%s</h2></center>",
            netsolveErrorMessage(ns_errno));
    return -1;
  }
  puts("<br>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  puts("<br>");

  puts("<br><hr width = 680 ><br>\n");
  printf("<A name=%s><h2>%s</h2></A>",pd->name,pd->name);
  puts("<br>");
  puts("<br>");
  fprintf(stdout,"<h3>PROBLEM DESCRIPTION</h3>\n");
  puts("<table border=2>");
  if (strstr(pd->description,"http://"))
  {
    cp=(char *) malloc(strlen(pd->description) * sizeof(char));
    strcpy(cp,pd->description);
    cp[strlen(cp)-strlen(strstr(pd->description,"http://"))]='\0';
    fprintf(stdout,"<tr><td>%s",cp);
    free(cp);
    puts("<br>");
    fprintf(stdout,"<a href= %s> %s </a></td></tr>",                                       strstr(pd->description,"http://"),strstr(pd->description,"http://"));
  }
  else
     fprintf(stdout,"<tr><td>%s</td></tr>",pd->description);
  puts("</table>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  fprintf(stdout,"<h3> %d OBJECT(S) IN  INPUT</h3>\n",pd->nb_input_objects);
  puts("<table border=2>");
  for (j=0;j<pd->nb_input_objects;j++)
  {
    puts("<tr><td>");
    fprintf(stdout,"input %d: ",j);
    displayObject(pd->input_objects[j]);
    puts("</td></tr>");
  }
  puts("</table>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  fprintf(stdout,"<h3> %d OBJECT(S) IN  OUTPUT</h3>\n",pd->nb_output_objects);
  puts("<table border=2>");
  for (j=0;j<pd->nb_output_objects;j++)
  {
    puts("<tr><td>");
    fprintf(stdout,"output %d: ",j);
    displayObject(pd->output_objects[j]);
    puts("</td></tr>");
  }
  puts("</table>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  puts("<br>");
  if (pd->nb_matlab_merge != 0)
  {
    fprintf(stdout,"<h3> MATLAB-MERGE </h3>");
    puts("<table border=2>");
    for (j=0;j<pd->nb_matlab_merge;j++)
    {
      fprintf(stdout,"<tr><td>Output Objects %d and %d can be merged</td></tr>",
                     pd->matlab_merge[j].index1,                                                     pd->matlab_merge[j].index2);
    }
   puts("</table>");
   puts("<br>");
   puts("<br>");
   puts("<br>");
   puts("<br>");
  }

  printCFortranCallingSequence(pd);

  freeProblemDesc(pd);
 }
 return 1;
}

/*
 * printCFortranCallingSequence()
 */
void printCFortranCallingSequence(NS_ProblemDesc *pd)
{
  int i;
  NS_CallingSequence *c = pd->calling_sequence;
  fprintf(stdout,"<h3> CALLING SEQUENCE FROM C OR FORTRAN:%d arguments</h3>",            c->nb_args);
  for (i=0;i<c->nb_args;i++)
  {
    char *m = strdup(c->arg_to_mnemonic[i]);
    char *buf;
    puts("<br>");
    puts("<br>");
    fprintf(stdout," Argument #%d:\n",i);
    buf = strtok(m,",\t \0");
    puts("<table border=2>");
    while (buf != NULL)
    {
      printMnemonicSemantic(pd,buf);
      buf = strtok(NULL,"\t ,");
    }
  puts("</table>");
  }
}

/*
 * printMnemonicSemantic()
 */
void printMnemonicSemantic(NS_ProblemDesc *pd,char *mnemonic)
{
  int io = getIO(mnemonic);
  int index = getIndex(mnemonic);

    puts("<tr><td>");
  switch(mnemonic[0])
  {
    case '?':
      fprintf(stdout,"   - ignored\n");
      break;
    case 'I':
      fprintf(stdout,"   - pointer to input object #%d (%s)\n",index,
                 pd->input_objects[index]->name);
      break;
    case 'O':
      fprintf(stdout,"   - pointer to output object #%d (%s)\n",index,
                 pd->output_objects[index]->name);
      break;
    case 'm':
      if (io == INPUT)
        fprintf(stdout,"   - number of rows of input object #%d (%s)\n",
                    index,pd->input_objects[index]->name);
      else
        fprintf(stdout,"   - number of columns of output object #%d (%s)\n",
                    index,pd->output_objects[index]->name);
      break;
    case 'n':
      if (io == INPUT)
        fprintf(stdout,"   - number of columns of input object #%d (%s)\n",
                    index,pd->input_objects[index]->name);
      else
        fprintf(stdout,"   - number of columns of output object #%d (%s)\n",
                    index,pd->output_objects[index]->name);
      break;
    case 'l':
      if (io == INPUT)
        fprintf(stdout,"   - leading dimension of input object #%d (%s)\n",
                    index,pd->input_objects[index]->name);
      else
        fprintf(stdout,"   - leading dimension of output object #%d (%s)\n",
                    index,pd->output_objects[index]->name);
      break;
    default:
      break;
  }
      puts("</td></tr>");
}

/*
 * displayObject()
 */
void displayObject(NS_Object *obj)
{
  switch(obj->object_type)
  {
    case NETSOLVE_MATRIX:
      fprintf(stdout,"Matrix ");
      break;
    case NETSOLVE_VECTOR:
      fprintf(stdout,"Vector ");
      break;
    case NETSOLVE_SCALAR:
      fprintf(stdout,"Scalar ");
      break;
    case NETSOLVE_UPF:
      fprintf(stdout,"Fortran/C Function in a file.");
      break;
    case NETSOLVE_FILE:
      fprintf(stdout,"File.");
      break;
    case NETSOLVE_PACKEDFILES:
      fprintf(stdout,"Packed files.");
      break;
/*
    case NETSOLVE_STRINGLIST:
      fprintf(stdout,"String list.");
      break;
*/
    case NETSOLVE_STRING:
      fprintf(stdout,"String.");
      break;
    default:
      fprintf(stdout,"???");
  }
  switch(obj->data_type)
  {
    case NETSOLVE_I:
      fprintf(stdout,"Integer.\n");
      break;
    case NETSOLVE_S:
      fprintf(stdout,"Single Precision Real.\n");
      break;
    case NETSOLVE_Z:
      fprintf(stdout,"Double Precision Complex.\n");
      break;
    case NETSOLVE_D:
      fprintf(stdout,"Double Precision Real.\n");
      break;
    case NETSOLVE_C:
      fprintf(stdout,"Single Precision Complex.\n");
      break;
    case NETSOLVE_B:
      fprintf(stdout,"Byte.\n");
      break;
    case NETSOLVE_CHAR:
/*
      if (obj->object_type == NETSOLVE_STRINGLIST)
        break;
*/
      if (obj->object_type == NETSOLVE_PACKEDFILES)
        break;
      if (obj->object_type == NETSOLVE_FILE)
        break;
      if (obj->object_type == NETSOLVE_STRING)
        break;
      if (obj->object_type == NETSOLVE_UPF)
        break;
      fprintf(stdout,"Character.\n");
      break;
    default:
      fprintf(stdout,"???");
  }
  fprintf(stdout,obj->description);
}
