/*-----------------------------------------------*/
/* Includes, constants and macros for the progam */
/*-----------------------------------------------*/
#include "core.h"
#include "mnemonics.h"
#include "client.h"
#include "netsolve_util.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
/* #include <ndbm.h> */
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <ctype.h>
#include "libcgi/cgi.h"

int postResponse(char *);
/*----------------------------------------*/
/* Mostly stub routine from cgi-lib files */
/*----------------------------------------*/

int cgi_main(cgi_info *ci) {
  char *parmval(form_entry *, char *);
  form_entry *parms, *p;
  form_entry *get_form_entries(cgi_info *);
  char *agent;
  int ftime(struct timeb* tp);
  struct timeb tb;
  double t1, t2;

  ftime(&tb);
  t1 = (double)(tb.time)+(double)tb.millitm/1000;

  print_mimeheader("text/html");

  parms = get_form_entries(ci);
  if (parms) {
    /* extract specific form parameters */
    for(p=parms; p; p = p->next) {
      if (!strcasecmp(p->name, "agent")) agent = p->val;
    }
  }

  puts("<html> <head>");
  puts("<title>NetSolve Hardware Resources</title>");
  puts("</head> <body BGCOLOR=#771122 text=yellow link=orange vlink=orange>");
  puts("<center><h1>NetSolve System</h1></center>");
  fprintf(stdout,"<center><h2>as seen by '<tt>%s</tt>'</h2></center>",
        agent);
  puts("<br><hr width = 500 ><br>\n");

  postResponse(agent);

  free_form_entries(parms);
  ftime(&tb);
  t2 = (double)(tb.time)+(double)tb.millitm/1000;
  puts("<center>");
  printf("<h4><hr>Elapsed wall-clock time: %f sec<br><hr>\n",t2-t1);
  puts("</center>");
  puts("</body> </html>");

  return 0;
}


int postResponse( char *agent)
{
  NS_ServerDesc **server_list;
  NS_AgentDesc **agent_list;
  int nb_servers;
  int nb_agents;
  int i;

  puts("<center>");
  nb_agents = get_agent_list(&agent_list, agent);
  /* Error */
  if (nb_agents == -1)
  {
   printf("<h2>%s</h2>",netsolveErrorMessage(ns_errno));
    return 0;
  }

  /* sorting the list */
  qsort(agent_list,nb_agents,sizeof(NS_AgentDesc *),agentOrder);
  puts("<table border=2>");

  /* Printing the list */
  for (i=0;i<nb_agents;i++)
  {
    fprintf(stdout,"<tr><td>AGENT: %s [%u.%u.%u.%u]</td></tr>\n",
                        agent_list[i]->host_desc->hostname,
                        BYTE(&(agent_list[i]->host_desc->IPaddr),0), 
                        BYTE(&(agent_list[i]->host_desc->IPaddr),1), 
                        BYTE(&(agent_list[i]->host_desc->IPaddr),2), 
                        BYTE(&(agent_list[i]->host_desc->IPaddr),3));
  }
  puts("</table>");
  puts("<br>");
  puts("<br>");
  puts("<br>");

  for (i=0;i<nb_agents;i++)
    freeAgentDesc(agent_list[i]);
  free(agent_list);

  nb_servers = get_server_list(&server_list, agent);

  /* Error */
  if (nb_servers == -1)
  {
   printf("<h2>%s</h2>",netsolveErrorMessage(ns_errno));
   return 0;
  }

  /* sorting the list */
  qsort(server_list,nb_servers,sizeof(NS_ServerDesc *),serverOrder);
  puts("<table border=2>");
  /* Printing the list */
  for (i=0;i<nb_servers;i++)
  {
    fprintf(stdout,"<tr><td>SERVER: %s [%u.%u.%u.%u] (%d failures)</tr></td>\n",
                           server_list[i]->host_desc->hostname,
                           BYTE(&(server_list[i]->host_desc->IPaddr),0),
                           BYTE(&(server_list[i]->host_desc->IPaddr),1),
                           BYTE(&(server_list[i]->host_desc->IPaddr),2),
                           BYTE(&(server_list[i]->host_desc->IPaddr),3),
                           server_list[i]->nb_failures);
  }
  puts("</table>");
  for (i=0;i<nb_servers;i++)
    freeServerDesc(server_list[i]);
  free(server_list);
  puts("</center>");
  return 1;
}
